/* *******************************************************************
 * Copyright (c) 2003 Contributors
 * All rights reserved. 
 * This program and the accompanying materials are made available 
 * under the terms of the Common Public License v1.0 
 * which accompanies this distribution and is available at 
 * http://www.eclipse.org/legal/cpl-v10.html 
 *  
 * Contributors: 
 *     Wes Isberg     initial implementation
 * ******************************************************************/

package org.aspectj.testing.drivers;

import junit.framework.*;

/*
 * Run harness tests as JUnit test suites.
 */
public class AjcHarnessTestsUsingJUnit extends TestCase {

    /**
     * Create TestSuite with harness validation tests.
     * @return Test with all TestSuites and TestCases
     *         for the harness itself.
     */
    public static TestSuite suite() {
        TestSuite result = HarnessJUnitUtil.suite(null, null, null);
        result.addTest(
            HarnessJUnitUtil.suite("harness", 
                new String[] {"../tests/ajcHarnessTests.xml"},
                new String[][] { 
                    new String[] {"-ajctestSkipKeywords=expect-fail"}
                    }
                ));
        result.addTest(
            HarnessJUnitUtil.suite("harness selection tests", 
                new String[] {"testdata/incremental/harness/selectionTest.xml"},
                null
                ));
        return result;
    }
        
	public AjcHarnessTestsUsingJUnit(String name) {
		super(name);
	}
}
